import torch
import numpy as np
import torch.nn as nn
import torch.optim as optim
import matplotlib.pyplot as plt
from IPython import display
display.set_matplotlib_formats('svg')
import torch.nn.functional as F

# https://arxiv.org/abs/1409.1556v6

class MyVGG(nn.Module):

    def __init__(self, n_in = 3, n_class = 1000):
        super().__init__()
        
        self.conv1 = nn.Conv2d(
                        in_channels=n_in, 
                        out_channels=64, 
                        kernel_size=(3,3), 
                        padding=(1,1), 
                        stride=(1,1))

        self.pool = nn.MaxPool2d(
                        kernel_size=(2, 2),
                        stride=(2, 2))
        
        #conv2, conv3, conv3, ...         
        
        #self.fc1 = nn.LazyLinear(4096)
        #self.fc2 = nn.LazyLinear(4096)
        #self.fc3 = nn.LazyLinear(n_class)        
                        
    def forward(self, x):
        x = F.relu(self.conv1(x))
        x = self.pool(x)
       
        #x = torch.flatten(x, 1) 
        #x = F.relu(self.fc1(x))
        #dropout
        #x = F.relu(self.fc2(x))
        #dropout
        #x = self.fc3(x)
        return x

model = MyVGG()

from torchsummary import summary

model = model.to("cpu")
test_tensor = torch.randn(1, 3, 224, 224)
model(test_tensor)
print(model)
summary(model, (3, 224, 224))

#pip install urllib3==1.26.6
import torchvision

torch_vgg11 = torchvision.models.vgg11(weights=None)
summary(torch_vgg11, (3, 224, 224))

torch_vgg11 = torchvision.models.vgg11_bn(weights=None)
summary(torch_vgg11, (3, 224, 224))
